var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { makeStyles, Text } from "./theme";
import { memo } from "react";
import { GlLogo } from "./utils/GlLogo";
import Paper from "@mui/material/Paper";
import { breakpointsValues } from "./theme";
import { Markdown } from "./tools/Markdown";
export var GlReviewSlide = memo(function (props) {
    var descriptionMd = props.descriptionMd, className = props.className, signature = props.signature, logoUrl = props.logoUrl, logoFill = props.logoFill;
    var _a = useStyles(undefined, { props: props }), classes = _a.classes, cx = _a.cx;
    return (_jsxs(Paper, __assign({ className: cx(classes.root, className) }, { children: [logoUrl !== undefined && (_jsx(GlLogo, { fill: logoFill, logoUrl: logoUrl, className: classes.logo })), _jsxs("div", { children: [descriptionMd !== undefined && (_jsx(Markdown, __assign({ className: classes.paragraph }, { children: descriptionMd }))), signature !== undefined && (_jsx(Text, __assign({ typo: "body 2", className: classes.signature }, { children: signature })))] })] })));
});
var useStyles = makeStyles({ "name": { GlReviewSlide: GlReviewSlide } })(function (theme) { return ({
    "root": {
        "display": "flex",
        "alignItems": "center",
        "justifyContent": "space-between",
        "flexDirection": (function () {
            if (theme.windowInnerWidth >= breakpointsValues.md) {
                return "row";
            }
            return "column";
        })(),
    },
    "paragraph": __assign(__assign({}, theme.typography.variants["body 1"].style), { "textAlign": (function () {
            if (theme.windowInnerWidth >= breakpointsValues.md) {
                return undefined;
            }
            return "center";
        })(), "margin": (function () {
            if (theme.windowInnerWidth >= breakpointsValues.sm) {
                return theme.spacing(5);
            }
            return theme.spacing({
                "topBottom": 1,
                "rightLeft": 5,
            });
        })() }),
    "signature": __assign(__assign({ "fontStyle": "italic" }, theme.spacing.rightLeft("margin", "".concat(theme.spacing(5), "px"))), { "marginBottom": theme.spacing(5), "textAlign": (function () {
            if (theme.windowInnerWidth >= breakpointsValues.md) {
                return "right";
            }
            return "center";
        })() }),
    "logo": __assign({ "width": 70, "& svg": {
            "width": 70,
            "height": 70,
        } }, (function () {
        if (theme.windowInnerWidth >= breakpointsValues.md) {
            return {
                "marginLeft": theme.spacing(5),
            };
        }
        return {
            "marginLeft": 0,
            "marginTop": theme.spacing(5),
        };
    })()),
}); });
//# sourceMappingURL=GlReviewSlide.js.map